#import <Cocoa/Cocoa.h>
#import <APPKit/NSTextField.h>

/**
 * Purpose: demonstrate GUI construction on Cocoa without using the
 * interface builder. This program is executable on both MacOSX and on
 * Windows running GNUstep.
 * Cst420 Foundations of Distributed Applications
 * see http://pooh.poly.asu.edu/Cst420
 * @author Tim Lindquist (Tim.Lindquist@asu.edu), ASU Polytechnic, Engineering
 * with credits to Casper B Hansen for structure of nibless of apps.
 * @version November 2010
 */
@interface AppDelegate : NSObject {
   NSWindow * window;
   NSView * view;
   NSTextField *titleLab, *authorLab, *commentLab, *urlLab, *albumLab,
               *categoryLab, *subcategoryLab;
   NSTextField *titleTB, *authorTB, *commentTB, *urlTB, *albumTB;
   NSComboBox *titleCB, *categoryCB, *subcategoryCB;
   NSTimer* aTimer;
   int fires;
}

- (id) init;
- (void) applicationWillFinishLaunching:(NSNotification *)notification;
- (void) applicationDidFinishLaunching:(NSNotification *)notification;
- (void) accumulateFires:(NSTimer*) theTimer;
- (void) addButtonWithTitle: (NSString*) aTitle
                     target: (id) anObject
                     action: (SEL) anAction
                       rect: (NSRect) aRect;
- (NSTextField*) addLabelWithTitle:(NSString*) aTitle at: (NSRect) aRect;
- (NSTextField*) addFieldWithTitle:(NSString*) aTitle at: (NSRect) aRect;
- (void) endIt;
- (BOOL) applicationShouldTerminate:(id) sender;
- (void) saveLib;
- (void) comboBoxSelectionDidChange: (NSNotification*)notification;
- (void) debug: (NSString*) aMessage;
- (void) dealloc;
@end
